using System.ServiceModel.Channels;

namespace Dynamicweb.Ecommerce.CheckoutHandlers.CyberSource.SimpleOrderApi
{
    /// <summary>
    /// Extends MessageEncoderFactory for providing CustomTextMessageEncoder instances
    /// </summary>
    public class CustomTextMessageEncoderFactory : MessageEncoderFactory
    {
        private MessageEncoder encoder;

        /// <summary>
        /// Default constructor
        /// </summary>
        internal CustomTextMessageEncoderFactory()
        {
            encoder = new CustomTextMessageEncoder(this);
        }

        /// <summary>
        /// Provides readonly acccess to CustomTextMessageEncoder
        /// </summary>
        public override MessageEncoder Encoder
        {
            get { return encoder; }
        }

        /// <summary>
        /// Retrieves message version
        /// </summary>
        public override MessageVersion MessageVersion
        {
            get { return MessageVersion.Soap12WSAddressing10; }
        }
    }
}
